#ifndef hlx_daemon_packet_hh_included
#define hlx_daemon_packet_hh_included 1

struct hlx_daemon_packet {
  unsigned short ver_type_subtype_retid;
  unsigned short sourceid;
  unsigned short firstOrbit_data0;
  unsigned short firstOrbit_data1;
  unsigned short lastOrbit_data2;
  unsigned short lastOrbit_data3;
  unsigned short set_seqn;
  unsigned short payloadLen;
  unsigned short unused0;
  unsigned short unused1;
  unsigned short unused2;
  unsigned short data[512];

  int version() const { return ver_type_subtype_retid&0xF; }
  int packetType() const { return (ver_type_subtype_retid>>4)&0xF; }
  int packetSubtype() const { return (ver_type_subtype_retid>>8)&0xF; }
  int retransmitId() const { return (ver_type_subtype_retid>>12)&0xF; }
  int histogramSet() const { return (set_seqn)&0xFF; }
  int histogramSeqNo() const { return (set_seqn>>8)&0xFF; }
  unsigned int firstOrbit() const { return firstOrbit_data0+(firstOrbit_data1<<16); }
  unsigned int lastOrbit() const { return lastOrbit_data2+(lastOrbit_data3<<16); }
  int payloadLength() const { return payloadLen&0xFFF; }
  void dump();
};



#endif // hlx_daemon_packet_hh_included


